import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, QueryList, TemplateRef } from '@angular/core';
import { Color } from '@mintplayer/ng-bootstrap';
import { BsSwipeContainerDirective } from '@mintplayer/ng-swiper';
import { BehaviorSubject, Observable } from 'rxjs';
import { BsCarouselImageDirective } from '../carousel-image/carousel-image.directive';
import * as i0 from "@angular/core";
export declare class BsCarouselComponent implements AfterViewInit, OnDestroy {
    private cdRef;
    constructor(platformId: any, cdRef: ChangeDetectorRef);
    colors: typeof Color;
    isServerSide: boolean;
    currentImageIndex: number;
    images$: BehaviorSubject<QueryList<BsCarouselImageDirective> | null>;
    imageCount$: Observable<number>;
    firstImageTemplate$: Observable<TemplateRef<any> | null>;
    lastImageTemplate$: Observable<TemplateRef<any> | null>;
    resizeObserver?: ResizeObserver;
    indicators: boolean;
    keyboardEvents: boolean;
    innerElement: ElementRef<HTMLDivElement>;
    swipeContainer: BsSwipeContainerDirective;
    set images(value: QueryList<BsCarouselImageDirective>);
    animationsDisabled: boolean;
    private _animation;
    set animation(value: 'fade' | 'slide');
    get animation(): 'fade' | 'slide';
    onKeyPress(ev: KeyboardEvent): void;
    previousImage(): void;
    nextImage(): void;
    imageCounter: number;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsCarouselComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsCarouselComponent, "bs-carousel", never, { "indicators": { "alias": "indicators"; "required": false; }; "keyboardEvents": { "alias": "keyboardEvents"; "required": false; }; "animation": { "alias": "animation"; "required": false; }; }, {}, ["images"], never, false, never>;
}
