import { AfterViewInit, ElementRef, EventEmitter } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { HS } from '../../interfaces/hs';
import * as i0 from "@angular/core";
export declare class BsColorWheelComponent implements AfterViewInit {
    private element;
    constructor(element: ElementRef<HTMLElement>);
    positionRelative: boolean;
    set diameterRatio(value: number);
    set width(value: number);
    set height(value: number);
    canvas: ElementRef<HTMLCanvasElement>;
    hs$: BehaviorSubject<HS>;
    hsChange: EventEmitter<HS>;
    get hs(): HS;
    set hs(value: HS);
    luminosity$: BehaviorSubject<number>;
    get luminosity(): number;
    set luminosity(value: number);
    private canvasContext;
    private isPointerDown;
    width$: BehaviorSubject<number>;
    height$: BehaviorSubject<number>;
    diameterRatio$: BehaviorSubject<number>;
    squareSize$: Observable<number | null>;
    shiftX$: Observable<number | null>;
    shiftY$: Observable<number | null>;
    innerRadius$: Observable<number | null>;
    outerRadius$: Observable<number | null>;
    markerPosition$: Observable<{
        x: number;
        y: number;
    }>;
    disabled$: BehaviorSubject<boolean>;
    viewInited$: BehaviorSubject<boolean>;
    ngAfterViewInit(): void;
    onPointerDown(ev: MouseEvent | TouchEvent): void;
    onPointerMove(ev: MouseEvent | TouchEvent): void;
    onMouseMove(ev: MouseEvent): void;
    onPointerUp(ev: MouseEvent | TouchEvent): void;
    private updateColor;
    private isInsideCircle;
    private position2color;
    private color2position;
    private rgb2Hsl;
    /**
     * Divide 1 to n, handling floating point errors.
     * Ensures that the value is in between 0 and 1.
     **/
    private bound01;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsColorWheelComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsColorWheelComponent, "bs-color-wheel", never, { "diameterRatio": { "alias": "diameterRatio"; "required": false; }; "width": { "alias": "width"; "required": false; }; "height": { "alias": "height"; "required": false; }; "hs": { "alias": "hs"; "required": false; }; "luminosity": { "alias": "luminosity"; "required": false; }; }, { "hsChange": "hsChange"; }, never, never, false, never>;
}
