import { AfterViewInit, DestroyRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { BsColorPickerComponent } from '../../components/color-picker/color-picker.component';
import { RgbColor } from '../../interfaces/rgb-color';
import * as i0 from "@angular/core";
export declare class BsColorPickerValueAccessor implements AfterViewInit, ControlValueAccessor {
    private host;
    private destroy;
    constructor(host: BsColorPickerComponent, destroy: DestroyRef);
    ngAfterViewInit(): void;
    hsl2rgb(h: number, s: number, l: number): RgbColor;
    onValueChange?: (value: string) => void;
    onTouched?: () => void;
    registerOnChange(fn: (_: any) => void): void;
    registerOnTouched(fn: () => void): void;
    writeValue(value: string | null): void;
    setDisabledState(isDisabled: boolean): void;
    private rgb2hex;
    private hex2rgb;
    /**
     * Divide 1 to n, handling floating point errors.
     * Ensures that the value is in between 0 and 1.
     **/
    private bound01;
    private rgb2Hsl;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsColorPickerValueAccessor, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BsColorPickerValueAccessor, "bs-color-picker", ["bsColorPicker"], {}, {}, never, never, false, never>;
}
