import { TemplateRef, EventEmitter } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { PaginationResponse } from '@mintplayer/pagination';
import { DatatableSettings } from '../datatable-settings';
import { BsDatatableColumnDirective } from '../datatable-column/datatable-column.directive';
import { BsRowTemplateContext } from '../row-template/row-template.directive';
import * as i0 from "@angular/core";
export declare class BsDatatableComponent<TData> {
    constructor();
    columns$: BehaviorSubject<BsDatatableColumnDirective[]>;
    numberOfColumns$: Observable<number>;
    set columns(value: BsDatatableColumnDirective[]);
    settings: DatatableSettings;
    data?: PaginationResponse<TData>;
    rowTemplate?: TemplateRef<BsRowTemplateContext<TData>>;
    settingsChange: EventEmitter<DatatableSettings>;
    columnHeaderClicked(column: BsDatatableColumnDirective): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsDatatableComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsDatatableComponent<any>, "bs-datatable", never, { "settings": { "alias": "settings"; "required": false; }; }, { "settingsChange": "settingsChange"; }, ["columns"], never, false, never>;
}
