import * as i0 from '@angular/core';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { EVENT_MANAGER_PLUGINS } from '@angular/platform-browser';
import { EMPTY } from 'rxjs';
import { take, switchMap } from 'rxjs/operators';

class BsBindEventPlugin {
    supports(event) {
        return event.startsWith('$.');
    }
    addEventListener(element, event) {
        const el = element;
        el[event] = EMPTY;
        const method = this.getMethod(element, event);
        const sub = this.manager.getZone()
            .onStable.pipe(take(1), switchMap(() => el[event]))
            .subscribe((value) => method(value));
        return () => sub.unsubscribe();
    }
    getMethod(element, event) {
        const el = element;
        const [, key, value, unit = ''] = event.split('.');
        if (event.endsWith('.attr')) {
            return (v) => element.setAttribute(key, String(v));
        }
        if (key === 'class') {
            return (v) => element.classList.toggle(value, !!v);
        }
        if (key === 'style') {
            return (v) => element.style.setProperty(value, `${v}${unit}`);
        }
        return (v) => (el[key] = v);
    }
}

class BsAsyncHostBindingModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsAsyncHostBindingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsAsyncHostBindingModule, imports: [CommonModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsAsyncHostBindingModule, providers: [
            {
                provide: EVENT_MANAGER_PLUGINS,
                useClass: BsBindEventPlugin,
                multi: true,
            },
        ], imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsAsyncHostBindingModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule
                    ],
                    providers: [
                        {
                            provide: EVENT_MANAGER_PLUGINS,
                            useClass: BsBindEventPlugin,
                            multi: true,
                        },
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsAsyncHostBindingModule, BsBindEventPlugin };
//# sourceMappingURL=mintplayer-ng-bootstrap-async-host-binding.mjs.map
