import * as i0 from '@angular/core';
import { Component, Input, ViewChild, NgModule } from '@angular/core';
import * as i1 from '@mintplayer/ng-bootstrap/copy';
import { BsCopyModule } from '@mintplayer/ng-bootstrap/copy';
import * as i2 from '@mintplayer/ng-bootstrap/offcanvas';
import { BsOffcanvasModule } from '@mintplayer/ng-bootstrap/offcanvas';
import * as i3 from 'ngx-highlightjs';
import { HighlightModule } from 'ngx-highlightjs';
import { CommonModule } from '@angular/common';

class BsCodeSnippetComponent {
    constructor() {
        this.offcanvasState = 'closed';
        this.codeToCopy = '';
        this.languages = null;
        this.lineNumbers = false;
    }
    copiedHtml() {
        this.offcanvasState = 'open';
        setTimeout(() => this.offcanvasState = 'closed', 3000);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsCodeSnippetComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.2", type: BsCodeSnippetComponent, selector: "bs-code-snippet", inputs: { codeToCopy: "codeToCopy", languages: "languages", lineNumbers: "lineNumbers" }, viewQueries: [{ propertyName: "copiedTemplate", first: true, predicate: ["copiedTemplate"], descendants: true }], ngImport: i0, template: "<div class=\"position-relative\">\n    <button #copyBtn [bsCopy]=\"codeToCopy\" (bsCopied)=\"copiedHtml()\" class=\"btn btn-link rounded-0 text-light position-absolute copy-btn\">\n        Copy html\n    </button>\n    <pre class=\"white-space-normal\">\n        <code class=\"d-block white-space-pre\" [highlight]=\"codeToCopy\" [lineNumbers]=\"lineNumbers\" [languages]=\"languages ?? undefined!\"></code>\n    </pre>\n    <bs-offcanvas [(state)]=\"offcanvasState\" [position]=\"'bottom'\">\n        <div *bsOffcanvasContent class=\"p-3\">Copied!</div>\n    </bs-offcanvas>\n</div>", styles: [".copy-btn{right:0}\n"], dependencies: [{ kind: "directive", type: i1.BsCopyDirective, selector: "[bsCopy]", inputs: ["bsCopy"], outputs: ["bsCopied"] }, { kind: "directive", type: i2.BsOffcanvasContentDirective, selector: "[bsOffcanvasContent]" }, { kind: "component", type: i2.BsOffcanvasHostComponent, selector: "bs-offcanvas", inputs: ["state", "position", "size", "hasBackdrop"], outputs: ["backdropClick", "stateChange"] }, { kind: "directive", type: i3.Highlight, selector: "[highlight]", inputs: ["highlight", "languages", "lineNumbers"], outputs: ["highlighted"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsCodeSnippetComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-code-snippet', template: "<div class=\"position-relative\">\n    <button #copyBtn [bsCopy]=\"codeToCopy\" (bsCopied)=\"copiedHtml()\" class=\"btn btn-link rounded-0 text-light position-absolute copy-btn\">\n        Copy html\n    </button>\n    <pre class=\"white-space-normal\">\n        <code class=\"d-block white-space-pre\" [highlight]=\"codeToCopy\" [lineNumbers]=\"lineNumbers\" [languages]=\"languages ?? undefined!\"></code>\n    </pre>\n    <bs-offcanvas [(state)]=\"offcanvasState\" [position]=\"'bottom'\">\n        <div *bsOffcanvasContent class=\"p-3\">Copied!</div>\n    </bs-offcanvas>\n</div>", styles: [".copy-btn{right:0}\n"] }]
        }], propDecorators: { codeToCopy: [{
                type: Input
            }], languages: [{
                type: Input
            }], lineNumbers: [{
                type: Input
            }], copiedTemplate: [{
                type: ViewChild,
                args: ['copiedTemplate']
            }] } });

class BsCodeSnippetModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsCodeSnippetModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsCodeSnippetModule, declarations: [BsCodeSnippetComponent], imports: [CommonModule,
            BsCopyModule,
            BsOffcanvasModule,
            HighlightModule], exports: [BsCodeSnippetComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsCodeSnippetModule, imports: [CommonModule,
            BsCopyModule,
            BsOffcanvasModule,
            HighlightModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsCodeSnippetModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsCodeSnippetComponent
                    ],
                    imports: [
                        CommonModule,
                        BsCopyModule,
                        BsOffcanvasModule,
                        HighlightModule
                    ],
                    exports: [
                        BsCodeSnippetComponent
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsCodeSnippetComponent, BsCodeSnippetModule };
//# sourceMappingURL=mintplayer-ng-bootstrap-code-snippet.mjs.map
