import * as i0 from '@angular/core';
import { Pipe, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

class BsFontColorPipe {
    transform(color_hex) {
        if (color_hex === undefined || color_hex === null || color_hex.length < 7 || typeof (color_hex) !== 'string') {
            return '#FFFFFF';
        }
        const R_HEX = color_hex.substr(1, 2);
        const G_HEX = color_hex.substr(3, 2);
        const B_HEX = color_hex.substr(5, 2);
        const R_DEC = parseInt(R_HEX, 16);
        const G_DEC = parseInt(G_HEX, 16);
        const B_DEC = parseInt(B_HEX, 16);
        const CONTRAST_HEX = R_DEC * 0.299 + G_DEC * 0.587 + B_DEC * 0.114 > 186 ? '#000000' : '#FFFFFF';
        return CONTRAST_HEX;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorPipe, name: "bsFontColor" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsFontColor'
                }]
        }] });

class BsFontColorModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorModule, declarations: [BsFontColorPipe], imports: [CommonModule], exports: [BsFontColorPipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsFontColorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFontColorPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsFontColorPipe
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsFontColorModule, BsFontColorPipe };
//# sourceMappingURL=mintplayer-ng-bootstrap-font-color.mjs.map
