import * as i0 from '@angular/core';
import { Component, Input, Directive, HostBinding, NgModule } from '@angular/core';
import { BehaviorSubject, map } from 'rxjs';
import * as i1 from '@mintplayer/ng-bootstrap/container';
import { BsContainerModule } from '@mintplayer/ng-bootstrap/container';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';

class BsGridComponent {
    constructor() {
        //#region StopFullWidthAt
        this.stopFullWidthAt$ = new BehaviorSubject('sm');
        this.containerClass$ = this.stopFullWidthAt$.pipe(map((stopFullWidthAt) => {
            switch (stopFullWidthAt) {
                case 'sm': return 'container';
                case 'never': return 'container-fluid';
                default: return `container-${stopFullWidthAt}`;
            }
        }));
    }
    get stopFullWidthAt() {
        return this.stopFullWidthAt$.value;
    }
    set stopFullWidthAt(value) {
        this.stopFullWidthAt$.next(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.2", type: BsGridComponent, selector: "bs-grid", inputs: { stopFullWidthAt: "stopFullWidthAt" }, ngImport: i0, template: "<bs-container>\n    <div [class]=\"containerClass$ | async\">\n        <ng-content></ng-content>\n    </div>\n</bs-container>", styles: [":host ::ng-deep :root{--bs-breakpoint-xs: 0;--bs-breakpoint-sm: 576px;--bs-breakpoint-md: 768px;--bs-breakpoint-lg: 992px;--bs-breakpoint-xl: 1200px;--bs-breakpoint-xxl: 1400px}:host ::ng-deep .row{--bs-gutter-x: 1.5rem;--bs-gutter-y: 0;display:flex;flex-wrap:wrap;margin-top:calc(-1 * var(--bs-gutter-y));margin-right:calc(-.5 * var(--bs-gutter-x));margin-left:calc(-.5 * var(--bs-gutter-x))}:host ::ng-deep .row>*{flex-shrink:0;width:100%;max-width:100%;padding-right:calc(var(--bs-gutter-x) * .5);padding-left:calc(var(--bs-gutter-x) * .5);margin-top:var(--bs-gutter-y)}:host ::ng-deep .col{flex:1 0 0%}:host ::ng-deep .row-cols-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-1{margin-left:8.33333333%}:host ::ng-deep .offset-2{margin-left:16.66666667%}:host ::ng-deep .offset-3{margin-left:25%}:host ::ng-deep .offset-4{margin-left:33.33333333%}:host ::ng-deep .offset-5{margin-left:41.66666667%}:host ::ng-deep .offset-6{margin-left:50%}:host ::ng-deep .offset-7{margin-left:58.33333333%}:host ::ng-deep .offset-8{margin-left:66.66666667%}:host ::ng-deep .offset-9{margin-left:75%}:host ::ng-deep .offset-10{margin-left:83.33333333%}:host ::ng-deep .offset-11{margin-left:91.66666667%}:host ::ng-deep .g-0,:host ::ng-deep .gx-0{--bs-gutter-x: 0}:host ::ng-deep .g-0,:host ::ng-deep .gy-0{--bs-gutter-y: 0}:host ::ng-deep .g-1,:host ::ng-deep .gx-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-1,:host ::ng-deep .gy-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-2,:host ::ng-deep .gx-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-2,:host ::ng-deep .gy-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-3,:host ::ng-deep .gx-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-3,:host ::ng-deep .gy-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-4,:host ::ng-deep .gx-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-4,:host ::ng-deep .gy-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-5,:host ::ng-deep .gx-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-5,:host ::ng-deep .gy-5{--bs-gutter-y: 3rem}@media (min-width: 576px){:host ::ng-deep .col-sm{flex:1 0 0%}:host ::ng-deep .row-cols-sm-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-sm-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-sm-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-sm-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-sm-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-sm-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-sm-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-sm-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-sm-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-sm-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-sm-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-sm-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-sm-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-sm-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-sm-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-sm-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-sm-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-sm-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-sm-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-sm-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-sm-0{margin-left:0}:host ::ng-deep .offset-sm-1{margin-left:8.33333333%}:host ::ng-deep .offset-sm-2{margin-left:16.66666667%}:host ::ng-deep .offset-sm-3{margin-left:25%}:host ::ng-deep .offset-sm-4{margin-left:33.33333333%}:host ::ng-deep .offset-sm-5{margin-left:41.66666667%}:host ::ng-deep .offset-sm-6{margin-left:50%}:host ::ng-deep .offset-sm-7{margin-left:58.33333333%}:host ::ng-deep .offset-sm-8{margin-left:66.66666667%}:host ::ng-deep .offset-sm-9{margin-left:75%}:host ::ng-deep .offset-sm-10{margin-left:83.33333333%}:host ::ng-deep .offset-sm-11{margin-left:91.66666667%}:host ::ng-deep .g-sm-0,:host ::ng-deep .gx-sm-0{--bs-gutter-x: 0}:host ::ng-deep .g-sm-0,:host ::ng-deep .gy-sm-0{--bs-gutter-y: 0}:host ::ng-deep .g-sm-1,:host ::ng-deep .gx-sm-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-sm-1,:host ::ng-deep .gy-sm-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-sm-2,:host ::ng-deep .gx-sm-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-sm-2,:host ::ng-deep .gy-sm-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-sm-3,:host ::ng-deep .gx-sm-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-sm-3,:host ::ng-deep .gy-sm-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-sm-4,:host ::ng-deep .gx-sm-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-sm-4,:host ::ng-deep .gy-sm-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-sm-5,:host ::ng-deep .gx-sm-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-sm-5,:host ::ng-deep .gy-sm-5{--bs-gutter-y: 3rem}}@media (min-width: 768px){:host ::ng-deep .col-md{flex:1 0 0%}:host ::ng-deep .row-cols-md-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-md-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-md-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-md-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-md-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-md-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-md-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-md-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-md-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-md-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-md-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-md-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-md-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-md-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-md-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-md-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-md-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-md-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-md-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-md-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-md-0{margin-left:0}:host ::ng-deep .offset-md-1{margin-left:8.33333333%}:host ::ng-deep .offset-md-2{margin-left:16.66666667%}:host ::ng-deep .offset-md-3{margin-left:25%}:host ::ng-deep .offset-md-4{margin-left:33.33333333%}:host ::ng-deep .offset-md-5{margin-left:41.66666667%}:host ::ng-deep .offset-md-6{margin-left:50%}:host ::ng-deep .offset-md-7{margin-left:58.33333333%}:host ::ng-deep .offset-md-8{margin-left:66.66666667%}:host ::ng-deep .offset-md-9{margin-left:75%}:host ::ng-deep .offset-md-10{margin-left:83.33333333%}:host ::ng-deep .offset-md-11{margin-left:91.66666667%}:host ::ng-deep .g-md-0,:host ::ng-deep .gx-md-0{--bs-gutter-x: 0}:host ::ng-deep .g-md-0,:host ::ng-deep .gy-md-0{--bs-gutter-y: 0}:host ::ng-deep .g-md-1,:host ::ng-deep .gx-md-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-md-1,:host ::ng-deep .gy-md-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-md-2,:host ::ng-deep .gx-md-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-md-2,:host ::ng-deep .gy-md-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-md-3,:host ::ng-deep .gx-md-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-md-3,:host ::ng-deep .gy-md-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-md-4,:host ::ng-deep .gx-md-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-md-4,:host ::ng-deep .gy-md-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-md-5,:host ::ng-deep .gx-md-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-md-5,:host ::ng-deep .gy-md-5{--bs-gutter-y: 3rem}}@media (min-width: 992px){:host ::ng-deep .col-lg{flex:1 0 0%}:host ::ng-deep .row-cols-lg-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-lg-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-lg-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-lg-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-lg-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-lg-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-lg-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-lg-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-lg-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-lg-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-lg-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-lg-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-lg-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-lg-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-lg-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-lg-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-lg-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-lg-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-lg-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-lg-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-lg-0{margin-left:0}:host ::ng-deep .offset-lg-1{margin-left:8.33333333%}:host ::ng-deep .offset-lg-2{margin-left:16.66666667%}:host ::ng-deep .offset-lg-3{margin-left:25%}:host ::ng-deep .offset-lg-4{margin-left:33.33333333%}:host ::ng-deep .offset-lg-5{margin-left:41.66666667%}:host ::ng-deep .offset-lg-6{margin-left:50%}:host ::ng-deep .offset-lg-7{margin-left:58.33333333%}:host ::ng-deep .offset-lg-8{margin-left:66.66666667%}:host ::ng-deep .offset-lg-9{margin-left:75%}:host ::ng-deep .offset-lg-10{margin-left:83.33333333%}:host ::ng-deep .offset-lg-11{margin-left:91.66666667%}:host ::ng-deep .g-lg-0,:host ::ng-deep .gx-lg-0{--bs-gutter-x: 0}:host ::ng-deep .g-lg-0,:host ::ng-deep .gy-lg-0{--bs-gutter-y: 0}:host ::ng-deep .g-lg-1,:host ::ng-deep .gx-lg-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-lg-1,:host ::ng-deep .gy-lg-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-lg-2,:host ::ng-deep .gx-lg-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-lg-2,:host ::ng-deep .gy-lg-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-lg-3,:host ::ng-deep .gx-lg-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-lg-3,:host ::ng-deep .gy-lg-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-lg-4,:host ::ng-deep .gx-lg-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-lg-4,:host ::ng-deep .gy-lg-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-lg-5,:host ::ng-deep .gx-lg-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-lg-5,:host ::ng-deep .gy-lg-5{--bs-gutter-y: 3rem}}@media (min-width: 1200px){:host ::ng-deep .col-xl{flex:1 0 0%}:host ::ng-deep .row-cols-xl-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-xl-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-xl-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-xl-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-xl-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-xl-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-xl-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-xl-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-xl-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-xl-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-xl-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-xl-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-xl-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-xl-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-xl-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-xl-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-xl-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-xl-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-xl-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-xl-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-xl-0{margin-left:0}:host ::ng-deep .offset-xl-1{margin-left:8.33333333%}:host ::ng-deep .offset-xl-2{margin-left:16.66666667%}:host ::ng-deep .offset-xl-3{margin-left:25%}:host ::ng-deep .offset-xl-4{margin-left:33.33333333%}:host ::ng-deep .offset-xl-5{margin-left:41.66666667%}:host ::ng-deep .offset-xl-6{margin-left:50%}:host ::ng-deep .offset-xl-7{margin-left:58.33333333%}:host ::ng-deep .offset-xl-8{margin-left:66.66666667%}:host ::ng-deep .offset-xl-9{margin-left:75%}:host ::ng-deep .offset-xl-10{margin-left:83.33333333%}:host ::ng-deep .offset-xl-11{margin-left:91.66666667%}:host ::ng-deep .g-xl-0,:host ::ng-deep .gx-xl-0{--bs-gutter-x: 0}:host ::ng-deep .g-xl-0,:host ::ng-deep .gy-xl-0{--bs-gutter-y: 0}:host ::ng-deep .g-xl-1,:host ::ng-deep .gx-xl-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-xl-1,:host ::ng-deep .gy-xl-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-xl-2,:host ::ng-deep .gx-xl-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-xl-2,:host ::ng-deep .gy-xl-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-xl-3,:host ::ng-deep .gx-xl-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-xl-3,:host ::ng-deep .gy-xl-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-xl-4,:host ::ng-deep .gx-xl-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-xl-4,:host ::ng-deep .gy-xl-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-xl-5,:host ::ng-deep .gx-xl-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-xl-5,:host ::ng-deep .gy-xl-5{--bs-gutter-y: 3rem}}@media (min-width: 1400px){:host ::ng-deep .col-xxl{flex:1 0 0%}:host ::ng-deep .row-cols-xxl-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-xxl-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-xxl-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-xxl-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-xxl-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-xxl-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-xxl-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-xxl-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-xxl-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-xxl-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-xxl-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-xxl-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-xxl-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-xxl-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-xxl-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-xxl-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-xxl-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-xxl-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-xxl-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-xxl-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-xxl-0{margin-left:0}:host ::ng-deep .offset-xxl-1{margin-left:8.33333333%}:host ::ng-deep .offset-xxl-2{margin-left:16.66666667%}:host ::ng-deep .offset-xxl-3{margin-left:25%}:host ::ng-deep .offset-xxl-4{margin-left:33.33333333%}:host ::ng-deep .offset-xxl-5{margin-left:41.66666667%}:host ::ng-deep .offset-xxl-6{margin-left:50%}:host ::ng-deep .offset-xxl-7{margin-left:58.33333333%}:host ::ng-deep .offset-xxl-8{margin-left:66.66666667%}:host ::ng-deep .offset-xxl-9{margin-left:75%}:host ::ng-deep .offset-xxl-10{margin-left:83.33333333%}:host ::ng-deep .offset-xxl-11{margin-left:91.66666667%}:host ::ng-deep .g-xxl-0,:host ::ng-deep .gx-xxl-0{--bs-gutter-x: 0}:host ::ng-deep .g-xxl-0,:host ::ng-deep .gy-xxl-0{--bs-gutter-y: 0}:host ::ng-deep .g-xxl-1,:host ::ng-deep .gx-xxl-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-xxl-1,:host ::ng-deep .gy-xxl-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-xxl-2,:host ::ng-deep .gx-xxl-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-xxl-2,:host ::ng-deep .gy-xxl-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-xxl-3,:host ::ng-deep .gx-xxl-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-xxl-3,:host ::ng-deep .gy-xxl-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-xxl-4,:host ::ng-deep .gx-xxl-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-xxl-4,:host ::ng-deep .gy-xxl-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-xxl-5,:host ::ng-deep .gx-xxl-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-xxl-5,:host ::ng-deep .gy-xxl-5{--bs-gutter-y: 3rem}}:host{display:contents}\n"], dependencies: [{ kind: "component", type: i1.BsContainerComponent, selector: "bs-container" }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-grid', template: "<bs-container>\n    <div [class]=\"containerClass$ | async\">\n        <ng-content></ng-content>\n    </div>\n</bs-container>", styles: [":host ::ng-deep :root{--bs-breakpoint-xs: 0;--bs-breakpoint-sm: 576px;--bs-breakpoint-md: 768px;--bs-breakpoint-lg: 992px;--bs-breakpoint-xl: 1200px;--bs-breakpoint-xxl: 1400px}:host ::ng-deep .row{--bs-gutter-x: 1.5rem;--bs-gutter-y: 0;display:flex;flex-wrap:wrap;margin-top:calc(-1 * var(--bs-gutter-y));margin-right:calc(-.5 * var(--bs-gutter-x));margin-left:calc(-.5 * var(--bs-gutter-x))}:host ::ng-deep .row>*{flex-shrink:0;width:100%;max-width:100%;padding-right:calc(var(--bs-gutter-x) * .5);padding-left:calc(var(--bs-gutter-x) * .5);margin-top:var(--bs-gutter-y)}:host ::ng-deep .col{flex:1 0 0%}:host ::ng-deep .row-cols-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-1{margin-left:8.33333333%}:host ::ng-deep .offset-2{margin-left:16.66666667%}:host ::ng-deep .offset-3{margin-left:25%}:host ::ng-deep .offset-4{margin-left:33.33333333%}:host ::ng-deep .offset-5{margin-left:41.66666667%}:host ::ng-deep .offset-6{margin-left:50%}:host ::ng-deep .offset-7{margin-left:58.33333333%}:host ::ng-deep .offset-8{margin-left:66.66666667%}:host ::ng-deep .offset-9{margin-left:75%}:host ::ng-deep .offset-10{margin-left:83.33333333%}:host ::ng-deep .offset-11{margin-left:91.66666667%}:host ::ng-deep .g-0,:host ::ng-deep .gx-0{--bs-gutter-x: 0}:host ::ng-deep .g-0,:host ::ng-deep .gy-0{--bs-gutter-y: 0}:host ::ng-deep .g-1,:host ::ng-deep .gx-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-1,:host ::ng-deep .gy-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-2,:host ::ng-deep .gx-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-2,:host ::ng-deep .gy-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-3,:host ::ng-deep .gx-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-3,:host ::ng-deep .gy-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-4,:host ::ng-deep .gx-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-4,:host ::ng-deep .gy-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-5,:host ::ng-deep .gx-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-5,:host ::ng-deep .gy-5{--bs-gutter-y: 3rem}@media (min-width: 576px){:host ::ng-deep .col-sm{flex:1 0 0%}:host ::ng-deep .row-cols-sm-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-sm-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-sm-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-sm-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-sm-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-sm-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-sm-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-sm-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-sm-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-sm-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-sm-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-sm-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-sm-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-sm-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-sm-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-sm-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-sm-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-sm-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-sm-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-sm-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-sm-0{margin-left:0}:host ::ng-deep .offset-sm-1{margin-left:8.33333333%}:host ::ng-deep .offset-sm-2{margin-left:16.66666667%}:host ::ng-deep .offset-sm-3{margin-left:25%}:host ::ng-deep .offset-sm-4{margin-left:33.33333333%}:host ::ng-deep .offset-sm-5{margin-left:41.66666667%}:host ::ng-deep .offset-sm-6{margin-left:50%}:host ::ng-deep .offset-sm-7{margin-left:58.33333333%}:host ::ng-deep .offset-sm-8{margin-left:66.66666667%}:host ::ng-deep .offset-sm-9{margin-left:75%}:host ::ng-deep .offset-sm-10{margin-left:83.33333333%}:host ::ng-deep .offset-sm-11{margin-left:91.66666667%}:host ::ng-deep .g-sm-0,:host ::ng-deep .gx-sm-0{--bs-gutter-x: 0}:host ::ng-deep .g-sm-0,:host ::ng-deep .gy-sm-0{--bs-gutter-y: 0}:host ::ng-deep .g-sm-1,:host ::ng-deep .gx-sm-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-sm-1,:host ::ng-deep .gy-sm-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-sm-2,:host ::ng-deep .gx-sm-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-sm-2,:host ::ng-deep .gy-sm-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-sm-3,:host ::ng-deep .gx-sm-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-sm-3,:host ::ng-deep .gy-sm-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-sm-4,:host ::ng-deep .gx-sm-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-sm-4,:host ::ng-deep .gy-sm-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-sm-5,:host ::ng-deep .gx-sm-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-sm-5,:host ::ng-deep .gy-sm-5{--bs-gutter-y: 3rem}}@media (min-width: 768px){:host ::ng-deep .col-md{flex:1 0 0%}:host ::ng-deep .row-cols-md-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-md-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-md-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-md-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-md-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-md-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-md-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-md-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-md-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-md-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-md-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-md-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-md-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-md-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-md-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-md-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-md-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-md-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-md-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-md-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-md-0{margin-left:0}:host ::ng-deep .offset-md-1{margin-left:8.33333333%}:host ::ng-deep .offset-md-2{margin-left:16.66666667%}:host ::ng-deep .offset-md-3{margin-left:25%}:host ::ng-deep .offset-md-4{margin-left:33.33333333%}:host ::ng-deep .offset-md-5{margin-left:41.66666667%}:host ::ng-deep .offset-md-6{margin-left:50%}:host ::ng-deep .offset-md-7{margin-left:58.33333333%}:host ::ng-deep .offset-md-8{margin-left:66.66666667%}:host ::ng-deep .offset-md-9{margin-left:75%}:host ::ng-deep .offset-md-10{margin-left:83.33333333%}:host ::ng-deep .offset-md-11{margin-left:91.66666667%}:host ::ng-deep .g-md-0,:host ::ng-deep .gx-md-0{--bs-gutter-x: 0}:host ::ng-deep .g-md-0,:host ::ng-deep .gy-md-0{--bs-gutter-y: 0}:host ::ng-deep .g-md-1,:host ::ng-deep .gx-md-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-md-1,:host ::ng-deep .gy-md-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-md-2,:host ::ng-deep .gx-md-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-md-2,:host ::ng-deep .gy-md-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-md-3,:host ::ng-deep .gx-md-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-md-3,:host ::ng-deep .gy-md-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-md-4,:host ::ng-deep .gx-md-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-md-4,:host ::ng-deep .gy-md-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-md-5,:host ::ng-deep .gx-md-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-md-5,:host ::ng-deep .gy-md-5{--bs-gutter-y: 3rem}}@media (min-width: 992px){:host ::ng-deep .col-lg{flex:1 0 0%}:host ::ng-deep .row-cols-lg-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-lg-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-lg-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-lg-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-lg-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-lg-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-lg-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-lg-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-lg-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-lg-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-lg-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-lg-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-lg-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-lg-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-lg-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-lg-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-lg-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-lg-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-lg-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-lg-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-lg-0{margin-left:0}:host ::ng-deep .offset-lg-1{margin-left:8.33333333%}:host ::ng-deep .offset-lg-2{margin-left:16.66666667%}:host ::ng-deep .offset-lg-3{margin-left:25%}:host ::ng-deep .offset-lg-4{margin-left:33.33333333%}:host ::ng-deep .offset-lg-5{margin-left:41.66666667%}:host ::ng-deep .offset-lg-6{margin-left:50%}:host ::ng-deep .offset-lg-7{margin-left:58.33333333%}:host ::ng-deep .offset-lg-8{margin-left:66.66666667%}:host ::ng-deep .offset-lg-9{margin-left:75%}:host ::ng-deep .offset-lg-10{margin-left:83.33333333%}:host ::ng-deep .offset-lg-11{margin-left:91.66666667%}:host ::ng-deep .g-lg-0,:host ::ng-deep .gx-lg-0{--bs-gutter-x: 0}:host ::ng-deep .g-lg-0,:host ::ng-deep .gy-lg-0{--bs-gutter-y: 0}:host ::ng-deep .g-lg-1,:host ::ng-deep .gx-lg-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-lg-1,:host ::ng-deep .gy-lg-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-lg-2,:host ::ng-deep .gx-lg-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-lg-2,:host ::ng-deep .gy-lg-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-lg-3,:host ::ng-deep .gx-lg-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-lg-3,:host ::ng-deep .gy-lg-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-lg-4,:host ::ng-deep .gx-lg-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-lg-4,:host ::ng-deep .gy-lg-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-lg-5,:host ::ng-deep .gx-lg-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-lg-5,:host ::ng-deep .gy-lg-5{--bs-gutter-y: 3rem}}@media (min-width: 1200px){:host ::ng-deep .col-xl{flex:1 0 0%}:host ::ng-deep .row-cols-xl-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-xl-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-xl-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-xl-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-xl-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-xl-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-xl-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-xl-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-xl-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-xl-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-xl-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-xl-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-xl-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-xl-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-xl-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-xl-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-xl-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-xl-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-xl-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-xl-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-xl-0{margin-left:0}:host ::ng-deep .offset-xl-1{margin-left:8.33333333%}:host ::ng-deep .offset-xl-2{margin-left:16.66666667%}:host ::ng-deep .offset-xl-3{margin-left:25%}:host ::ng-deep .offset-xl-4{margin-left:33.33333333%}:host ::ng-deep .offset-xl-5{margin-left:41.66666667%}:host ::ng-deep .offset-xl-6{margin-left:50%}:host ::ng-deep .offset-xl-7{margin-left:58.33333333%}:host ::ng-deep .offset-xl-8{margin-left:66.66666667%}:host ::ng-deep .offset-xl-9{margin-left:75%}:host ::ng-deep .offset-xl-10{margin-left:83.33333333%}:host ::ng-deep .offset-xl-11{margin-left:91.66666667%}:host ::ng-deep .g-xl-0,:host ::ng-deep .gx-xl-0{--bs-gutter-x: 0}:host ::ng-deep .g-xl-0,:host ::ng-deep .gy-xl-0{--bs-gutter-y: 0}:host ::ng-deep .g-xl-1,:host ::ng-deep .gx-xl-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-xl-1,:host ::ng-deep .gy-xl-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-xl-2,:host ::ng-deep .gx-xl-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-xl-2,:host ::ng-deep .gy-xl-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-xl-3,:host ::ng-deep .gx-xl-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-xl-3,:host ::ng-deep .gy-xl-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-xl-4,:host ::ng-deep .gx-xl-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-xl-4,:host ::ng-deep .gy-xl-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-xl-5,:host ::ng-deep .gx-xl-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-xl-5,:host ::ng-deep .gy-xl-5{--bs-gutter-y: 3rem}}@media (min-width: 1400px){:host ::ng-deep .col-xxl{flex:1 0 0%}:host ::ng-deep .row-cols-xxl-auto>*{flex:0 0 auto;width:auto}:host ::ng-deep .row-cols-xxl-1>*{flex:0 0 auto;width:100%}:host ::ng-deep .row-cols-xxl-2>*{flex:0 0 auto;width:50%}:host ::ng-deep .row-cols-xxl-3>*{flex:0 0 auto;width:33.3333333333%}:host ::ng-deep .row-cols-xxl-4>*{flex:0 0 auto;width:25%}:host ::ng-deep .row-cols-xxl-5>*{flex:0 0 auto;width:20%}:host ::ng-deep .row-cols-xxl-6>*{flex:0 0 auto;width:16.6666666667%}:host ::ng-deep .col-xxl-auto{flex:0 0 auto;width:auto}:host ::ng-deep .col-xxl-1{flex:0 0 auto;width:8.33333333%}:host ::ng-deep .col-xxl-2{flex:0 0 auto;width:16.66666667%}:host ::ng-deep .col-xxl-3{flex:0 0 auto;width:25%}:host ::ng-deep .col-xxl-4{flex:0 0 auto;width:33.33333333%}:host ::ng-deep .col-xxl-5{flex:0 0 auto;width:41.66666667%}:host ::ng-deep .col-xxl-6{flex:0 0 auto;width:50%}:host ::ng-deep .col-xxl-7{flex:0 0 auto;width:58.33333333%}:host ::ng-deep .col-xxl-8{flex:0 0 auto;width:66.66666667%}:host ::ng-deep .col-xxl-9{flex:0 0 auto;width:75%}:host ::ng-deep .col-xxl-10{flex:0 0 auto;width:83.33333333%}:host ::ng-deep .col-xxl-11{flex:0 0 auto;width:91.66666667%}:host ::ng-deep .col-xxl-12{flex:0 0 auto;width:100%}:host ::ng-deep .offset-xxl-0{margin-left:0}:host ::ng-deep .offset-xxl-1{margin-left:8.33333333%}:host ::ng-deep .offset-xxl-2{margin-left:16.66666667%}:host ::ng-deep .offset-xxl-3{margin-left:25%}:host ::ng-deep .offset-xxl-4{margin-left:33.33333333%}:host ::ng-deep .offset-xxl-5{margin-left:41.66666667%}:host ::ng-deep .offset-xxl-6{margin-left:50%}:host ::ng-deep .offset-xxl-7{margin-left:58.33333333%}:host ::ng-deep .offset-xxl-8{margin-left:66.66666667%}:host ::ng-deep .offset-xxl-9{margin-left:75%}:host ::ng-deep .offset-xxl-10{margin-left:83.33333333%}:host ::ng-deep .offset-xxl-11{margin-left:91.66666667%}:host ::ng-deep .g-xxl-0,:host ::ng-deep .gx-xxl-0{--bs-gutter-x: 0}:host ::ng-deep .g-xxl-0,:host ::ng-deep .gy-xxl-0{--bs-gutter-y: 0}:host ::ng-deep .g-xxl-1,:host ::ng-deep .gx-xxl-1{--bs-gutter-x: .25rem}:host ::ng-deep .g-xxl-1,:host ::ng-deep .gy-xxl-1{--bs-gutter-y: .25rem}:host ::ng-deep .g-xxl-2,:host ::ng-deep .gx-xxl-2{--bs-gutter-x: .5rem}:host ::ng-deep .g-xxl-2,:host ::ng-deep .gy-xxl-2{--bs-gutter-y: .5rem}:host ::ng-deep .g-xxl-3,:host ::ng-deep .gx-xxl-3{--bs-gutter-x: 1rem}:host ::ng-deep .g-xxl-3,:host ::ng-deep .gy-xxl-3{--bs-gutter-y: 1rem}:host ::ng-deep .g-xxl-4,:host ::ng-deep .gx-xxl-4{--bs-gutter-x: 1.5rem}:host ::ng-deep .g-xxl-4,:host ::ng-deep .gy-xxl-4{--bs-gutter-y: 1.5rem}:host ::ng-deep .g-xxl-5,:host ::ng-deep .gx-xxl-5{--bs-gutter-x: 3rem}:host ::ng-deep .g-xxl-5,:host ::ng-deep .gy-xxl-5{--bs-gutter-y: 3rem}}:host{display:contents}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { stopFullWidthAt: [{
                type: Input
            }] } });

class BsGridRowDirective {
    constructor() {
        this.rowClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridRowDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsGridRowDirective, selector: "[bsRow]", host: { properties: { "class.row": "this.rowClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridRowDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsRow]'
                }]
        }], propDecorators: { rowClass: [{
                type: HostBinding,
                args: ['class.row']
            }] } });

class BsGridColumnDirective {
    constructor(destroy) {
        this.customColClasses$ = new BehaviorSubject(undefined);
        this.classList = null;
        this.customColClasses$
            .pipe(map((data) => {
            if (!data) {
                return 'col';
            }
            else {
                return Object.keys(data)
                    .map(key => ({
                    key,
                    value: data[key]
                }))
                    .map(v => {
                    if (v.key === '_') {
                        return `col-${v.value}`;
                    }
                    else {
                        return `col-${v.key}-${v.value}`;
                    }
                })
                    .join(' ');
            }
        }))
            .pipe(takeUntilDestroyed(destroy))
            .subscribe((classList) => {
            this.classList = classList;
        });
    }
    set bsColumn(value) {
        this.customColClasses$.next(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridColumnDirective, deps: [{ token: i0.DestroyRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsGridColumnDirective, selector: "[bsColumn]", inputs: { bsColumn: "bsColumn" }, host: { properties: { "class": "this.classList" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridColumnDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsColumn]'
                }]
        }], ctorParameters: function () { return [{ type: i0.DestroyRef }]; }, propDecorators: { classList: [{
                type: HostBinding,
                args: ['class']
            }], bsColumn: [{
                type: Input
            }] } });

class BsColFormLabelDirective {
    constructor() {
        this.colFormLabelClass = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsColFormLabelDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsColFormLabelDirective, selector: "[bsColFormLabel]", host: { properties: { "class.col-form-label": "this.colFormLabelClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsColFormLabelDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsColFormLabel]'
                }]
        }], propDecorators: { colFormLabelClass: [{
                type: HostBinding,
                args: ['class.col-form-label']
            }] } });

class BsGridModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsGridModule, declarations: [BsGridComponent, BsGridRowDirective, BsGridColumnDirective, BsColFormLabelDirective], imports: [CommonModule, BsContainerModule], exports: [BsGridComponent, BsGridRowDirective, BsGridColumnDirective, BsColFormLabelDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridModule, imports: [CommonModule, BsContainerModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsGridModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [BsGridComponent, BsGridRowDirective, BsGridColumnDirective, BsColFormLabelDirective],
                    imports: [CommonModule, BsContainerModule],
                    exports: [BsGridComponent, BsGridRowDirective, BsGridColumnDirective, BsColFormLabelDirective],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsColFormLabelDirective, BsGridColumnDirective, BsGridComponent, BsGridModule, BsGridRowDirective };
//# sourceMappingURL=mintplayer-ng-bootstrap-grid.mjs.map
