import * as i0 from '@angular/core';
import { EventEmitter, Component, Optional, ViewChild, Input, Output, Directive, NgModule } from '@angular/core';
import * as i3 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i5 from '@mintplayer/ng-bootstrap/let';
import { BsLetModule } from '@mintplayer/ng-bootstrap/let';
import * as i6 from '@mintplayer/ng-bootstrap/icon';
import { BsIconModule } from '@mintplayer/ng-bootstrap/icon';
import * as i4 from '@mintplayer/ng-focus-on-load';
import { FocusOnLoadModule } from '@mintplayer/ng-focus-on-load';
import * as i7 from '@mintplayer/ng-bootstrap/dropdown';
import { BsDropdownModule } from '@mintplayer/ng-bootstrap/dropdown';
import * as i11 from '@mintplayer/ng-bootstrap/progress-bar';
import { BsProgressBarModule } from '@mintplayer/ng-bootstrap/progress-bar';
import * as i9 from '@mintplayer/ng-bootstrap/dropdown-menu';
import { BsDropdownMenuModule } from '@mintplayer/ng-bootstrap/dropdown-menu';
import * as i10 from '@mintplayer/ng-bootstrap/button-type';
import { BsButtonTypeModule } from '@mintplayer/ng-bootstrap/button-type';
import * as i8 from '@mintplayer/ng-bootstrap/has-overlay';
import { BsHasOverlayModule } from '@mintplayer/ng-bootstrap/has-overlay';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { Color } from '@mintplayer/ng-bootstrap';
import * as i1 from '@mintplayer/ng-bootstrap/form';
import { BehaviorSubject, debounceTime } from 'rxjs';

class BsSearchboxComponent {
    constructor(bsForm) {
        this.colors = Color;
        this.isBusy$ = new BehaviorSubject(false);
        //#region isOpen
        this._isOpen = false;
        //#endregion
        //#region suggestions
        this._suggestions = [];
        this.selectedItemChange = new EventEmitter();
        //#endregion
        //#region searchterm
        this.searchterm$ = new BehaviorSubject('');
        this.provideSuggestions = new EventEmitter();
        if (!bsForm) {
            throw '<bs-searchbox> must be inside a <bs-form>';
        }
        this.searchterm$.pipe(debounceTime(200), takeUntilDestroyed()).subscribe((searchterm) => {
            if (searchterm === '') {
                this.suggestions = [];
            }
            else {
                this.isBusy$.next(true);
                this.provideSuggestions.emit(searchterm);
            }
        });
    }
    get isOpen() {
        return this._isOpen;
    }
    set isOpen(value) {
        const changed = (this._isOpen !== value);
        this._isOpen = value;
        if (changed && value) {
            setTimeout(() => this.textbox.nativeElement.setSelectionRange(0, -1), 20);
        }
    }
    get suggestions() {
        return this._suggestions;
    }
    set suggestions(value) {
        this._suggestions = value;
        this.isBusy$.next(false);
    }
    get selectedItem() {
        return this._selectedItem;
    }
    set selectedItem(value) {
        this._selectedItem = value;
        this.selectedItemChange.emit(value);
    }
    ;
    get searchterm() {
        return this.searchterm$.value;
    }
    set searchterm(value) {
        this.searchterm$.next(value);
    }
    onSearchtermChange(searchterm) {
        this.searchterm$.next(searchterm);
    }
    onSuggestionClicked(suggestion) {
        this.selectedItem = suggestion;
        this.isOpen = false;
        this.searchterm = '';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSearchboxComponent, deps: [{ token: i1.BsFormComponent, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.2", type: BsSearchboxComponent, selector: "bs-searchbox", inputs: { isOpen: "isOpen", suggestions: "suggestions", selectedItem: "selectedItem", searchterm: "searchterm" }, outputs: { selectedItemChange: "selectedItemChange", provideSuggestions: "provideSuggestions" }, viewQueries: [{ propertyName: "textbox", first: true, predicate: ["textbox"], descendants: true }], ngImport: i0, template: "<bs-has-overlay></bs-has-overlay>\n<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [sameDropdownWidth]=\"true\">\n    <button [color]=\"colors.primary\" class=\"d-flex w-100\" bsDropdownToggle>\n        <div class=\"flex-grow-1\">\n            <ng-content *ngIf=\"!selectedItem\"></ng-content>\n            <ng-container *ngIf=\"selectedItem && suggestionTemplate\">\n                <ng-container *ngTemplateOutlet=\"suggestionTemplate; context: { $implicit: selectedItem, searchbox: this }\"></ng-container>\n            </ng-container>\n        </div>\n        <bs-icon [icon]=\"isOpen ? 'caret-up-fill' : 'caret-down-fill'\" class=\"float-end\"></bs-icon>\n    </button>\n    <bs-dropdown-menu *bsDropdownMenu>\n        <ng-container *bsLet=\"(isBusy$ | async) as isBusy\">\n            <bs-progress [isIndeterminate]=\"true\" class=\"prog\" *ngIf=\"isBusy\">\n                <bs-progress-bar></bs-progress-bar>\n            </bs-progress>\n            <div class=\"w-100 px-2 mb-2\">\n                <input type=\"text\" #textbox autofocus class=\"form-control d-block\" [ngModel]=\"searchterm$ | async\" (ngModelChange)=\"onSearchtermChange($event)\">\n            </div>\n            \n            <bs-dropdown-item [disabled]=\"true\" *ngIf=\"searchterm === ''\">\n                <ng-container *ngTemplateOutlet=\"enterSearchtermTemplate ?? defaultEnterSearchtermTemplate; context: { }\"></ng-container>\n            </bs-dropdown-item>\n            <div *ngIf=\"searchterm !== ''\" class=\"overflow-y-auto\" [style.max-height.px]=\"200\">\n                <bs-dropdown-item *ngFor=\"let suggestion of suggestions\" (click)=\"onSuggestionClicked(suggestion)\" [isSelected]=\"selectedItem?.id === suggestion.id\" [disabled]=\"isBusy ?? true\">\n                    <ng-container *ngIf=\"suggestionTemplate\">\n                        <ng-container *ngTemplateOutlet=\"suggestionTemplate; context: { $implicit: suggestion, searchbox: this }\"></ng-container>\n                    </ng-container>\n                </bs-dropdown-item>\n                <bs-dropdown-item *ngIf=\"suggestions.length === 0\" [disabled]=\"true\">\n                    <ng-container *ngTemplateOutlet=\"noResultsTemplate ?? defaultNoResultsTemplate; context: { }\"></ng-container>\n                </bs-dropdown-item>\n            </div>\n        </ng-container>\n    </bs-dropdown-menu>\n</div>\n\n<ng-template #defaultEnterSearchtermTemplate>\n    Enter a search term\n</ng-template>\n<ng-template #defaultNoResultsTemplate>\n    No results\n</ng-template>", styles: [".prog{height:.3rem;margin-top:-.5rem;margin-bottom:.2rem}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i4.FocusOnLoadDirective, selector: "*[autofocus]", inputs: ["autofocus"] }, { kind: "directive", type: i5.BsLetDirective, selector: "[bsLet]", inputs: ["bsLet"] }, { kind: "component", type: i6.BsIconComponent, selector: "bs-icon", inputs: ["icon"] }, { kind: "directive", type: i7.BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { kind: "directive", type: i7.BsDropdownToggleDirective, selector: "[bsDropdownToggle]" }, { kind: "directive", type: i7.BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { kind: "component", type: i8.BsHasOverlayComponent, selector: "bs-has-overlay" }, { kind: "component", type: i9.BsDropdownMenuComponent, selector: "bs-dropdown-menu", inputs: ["maxHeight"] }, { kind: "component", type: i9.BsDropdownItemComponent, selector: "bs-dropdown-item", inputs: ["isSelected", "disabled"] }, { kind: "directive", type: i10.BsButtonTypeDirective, selector: "button[color],input[type=\"button\"][color],input[type=\"submit\"][color]", inputs: ["color"] }, { kind: "component", type: i11.BsProgressBarComponent, selector: "bs-progress-bar", inputs: ["minimum", "maximum", "value", "color", "striped", "animated"] }, { kind: "component", type: i11.BsProgressComponent, selector: "bs-progress", inputs: ["height", "isIndeterminate"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSearchboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-searchbox', template: "<bs-has-overlay></bs-has-overlay>\n<div bsDropdown [(isOpen)]=\"isOpen\" [hasBackdrop]=\"false\" [sameDropdownWidth]=\"true\">\n    <button [color]=\"colors.primary\" class=\"d-flex w-100\" bsDropdownToggle>\n        <div class=\"flex-grow-1\">\n            <ng-content *ngIf=\"!selectedItem\"></ng-content>\n            <ng-container *ngIf=\"selectedItem && suggestionTemplate\">\n                <ng-container *ngTemplateOutlet=\"suggestionTemplate; context: { $implicit: selectedItem, searchbox: this }\"></ng-container>\n            </ng-container>\n        </div>\n        <bs-icon [icon]=\"isOpen ? 'caret-up-fill' : 'caret-down-fill'\" class=\"float-end\"></bs-icon>\n    </button>\n    <bs-dropdown-menu *bsDropdownMenu>\n        <ng-container *bsLet=\"(isBusy$ | async) as isBusy\">\n            <bs-progress [isIndeterminate]=\"true\" class=\"prog\" *ngIf=\"isBusy\">\n                <bs-progress-bar></bs-progress-bar>\n            </bs-progress>\n            <div class=\"w-100 px-2 mb-2\">\n                <input type=\"text\" #textbox autofocus class=\"form-control d-block\" [ngModel]=\"searchterm$ | async\" (ngModelChange)=\"onSearchtermChange($event)\">\n            </div>\n            \n            <bs-dropdown-item [disabled]=\"true\" *ngIf=\"searchterm === ''\">\n                <ng-container *ngTemplateOutlet=\"enterSearchtermTemplate ?? defaultEnterSearchtermTemplate; context: { }\"></ng-container>\n            </bs-dropdown-item>\n            <div *ngIf=\"searchterm !== ''\" class=\"overflow-y-auto\" [style.max-height.px]=\"200\">\n                <bs-dropdown-item *ngFor=\"let suggestion of suggestions\" (click)=\"onSuggestionClicked(suggestion)\" [isSelected]=\"selectedItem?.id === suggestion.id\" [disabled]=\"isBusy ?? true\">\n                    <ng-container *ngIf=\"suggestionTemplate\">\n                        <ng-container *ngTemplateOutlet=\"suggestionTemplate; context: { $implicit: suggestion, searchbox: this }\"></ng-container>\n                    </ng-container>\n                </bs-dropdown-item>\n                <bs-dropdown-item *ngIf=\"suggestions.length === 0\" [disabled]=\"true\">\n                    <ng-container *ngTemplateOutlet=\"noResultsTemplate ?? defaultNoResultsTemplate; context: { }\"></ng-container>\n                </bs-dropdown-item>\n            </div>\n        </ng-container>\n    </bs-dropdown-menu>\n</div>\n\n<ng-template #defaultEnterSearchtermTemplate>\n    Enter a search term\n</ng-template>\n<ng-template #defaultNoResultsTemplate>\n    No results\n</ng-template>", styles: [".prog{height:.3rem;margin-top:-.5rem;margin-bottom:.2rem}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.BsFormComponent, decorators: [{
                    type: Optional
                }] }]; }, propDecorators: { textbox: [{
                type: ViewChild,
                args: ['textbox']
            }], isOpen: [{
                type: Input
            }], suggestions: [{
                type: Input
            }], selectedItem: [{
                type: Input
            }], selectedItemChange: [{
                type: Output
            }], searchterm: [{
                type: Input
            }], provideSuggestions: [{
                type: Output
            }] } });

class BsEnterSearchTermTemplateDirective {
    constructor(searchbox, template) {
        searchbox.enterSearchtermTemplate = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsEnterSearchTermTemplateDirective, deps: [{ token: BsSearchboxComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsEnterSearchTermTemplateDirective, selector: "[bsEnterSearchTermTemplate]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsEnterSearchTermTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsEnterSearchTermTemplate]',
                }]
        }], ctorParameters: function () { return [{ type: BsSearchboxComponent }, { type: i0.TemplateRef }]; } });

class BsSuggestionTemplateDirective {
    constructor(searchbox, template) {
        this.searchbox = searchbox;
        searchbox.suggestionTemplate = template;
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    set bsSuggestionTemplateOf(value) {
        this.searchbox.suggestions = value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSuggestionTemplateDirective, deps: [{ token: BsSearchboxComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsSuggestionTemplateDirective, selector: "[bsSuggestionTemplate]", inputs: { bsSuggestionTemplateOf: "bsSuggestionTemplateOf" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSuggestionTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsSuggestionTemplate]',
                }]
        }], ctorParameters: function () { return [{ type: BsSearchboxComponent }, { type: i0.TemplateRef }]; }, propDecorators: { bsSuggestionTemplateOf: [{
                type: Input
            }] } });
class BsSuggestionTemplateContext {
    constructor() {
        this.$implicit = null;
        this.searchbox = null;
    }
}

class BsNoResultsTemplateDirective {
    constructor(searchbox, template) {
        searchbox.noResultsTemplate = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsNoResultsTemplateDirective, deps: [{ token: BsSearchboxComponent }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsNoResultsTemplateDirective, selector: "[bsNoResultsTemplate]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsNoResultsTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsNoResultsTemplate]',
                }]
        }], ctorParameters: function () { return [{ type: BsSearchboxComponent }, { type: i0.TemplateRef }]; } });

class BsSearchboxModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSearchboxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsSearchboxModule, declarations: [BsSearchboxComponent,
            BsEnterSearchTermTemplateDirective,
            BsSuggestionTemplateDirective,
            BsNoResultsTemplateDirective], imports: [CommonModule,
            FormsModule,
            FocusOnLoadModule,
            BsLetModule,
            BsIconModule,
            BsDropdownModule,
            BsDropdownMenuModule,
            BsButtonTypeModule,
            BsProgressBarModule,
            BsHasOverlayModule], exports: [BsSearchboxComponent,
            BsEnterSearchTermTemplateDirective,
            BsSuggestionTemplateDirective,
            BsNoResultsTemplateDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSearchboxModule, imports: [CommonModule,
            FormsModule,
            FocusOnLoadModule,
            BsLetModule,
            BsIconModule,
            BsDropdownModule,
            BsDropdownMenuModule,
            BsButtonTypeModule,
            BsProgressBarModule,
            BsHasOverlayModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSearchboxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSearchboxComponent,
                        BsEnterSearchTermTemplateDirective,
                        BsSuggestionTemplateDirective,
                        BsNoResultsTemplateDirective,
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        FocusOnLoadModule,
                        BsLetModule,
                        BsIconModule,
                        BsDropdownModule,
                        BsDropdownMenuModule,
                        BsButtonTypeModule,
                        BsProgressBarModule,
                        BsHasOverlayModule,
                    ],
                    exports: [
                        BsSearchboxComponent,
                        BsEnterSearchTermTemplateDirective,
                        BsSuggestionTemplateDirective,
                        BsNoResultsTemplateDirective,
                    ],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsEnterSearchTermTemplateDirective, BsNoResultsTemplateDirective, BsSearchboxComponent, BsSearchboxModule, BsSuggestionTemplateContext, BsSuggestionTemplateDirective };
//# sourceMappingURL=mintplayer-ng-bootstrap-searchbox.mjs.map
