import * as i0 from '@angular/core';
import { Pipe, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

class BsSlugifyPipe {
    transform(value) {
        return value.toString().toLowerCase()
            .replace(/\s+/g, '-') // Replace spaces with -
            .normalize("NFD").replace(/[\u0300-\u036f]/g, "") // Remove diacritics
            .replace(/[^\w\-]+/g, '') // Remove all non-word chars
            .replace(/\-\-+/g, '-') // Replace multiple - with single -
            .replace(/^-+/, '') // Trim - from start of text
            .replace(/-+$/, ''); // Trim - from end of text
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyPipe, name: "bsSlugify" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsSlugify',
                }]
        }] });

class BsSlugifyModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyModule, declarations: [BsSlugifyPipe], imports: [CommonModule], exports: [BsSlugifyPipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsSlugifyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [BsSlugifyPipe],
                    imports: [CommonModule],
                    exports: [BsSlugifyPipe],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsSlugifyModule, BsSlugifyPipe };
//# sourceMappingURL=mintplayer-ng-bootstrap-slugify.mjs.map
