import * as i0 from '@angular/core';
import { Directive, HostBinding, PLATFORM_ID, Component, Inject, ViewChild, NgModule } from '@angular/core';
import { isPlatformServer, CommonModule } from '@angular/common';

class BsStickyFooterParentDirective {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterParentDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.1.2", type: BsStickyFooterParentDirective, selector: "[bsStickyFooterParent]", host: { properties: { "style.margin-bottom.px": "this.marginBottom" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterParentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsStickyFooterParent]',
                }]
        }], propDecorators: { marginBottom: [{
                type: HostBinding,
                args: ['style.margin-bottom.px']
            }] } });

class BsStickyFooterComponent {
    constructor(parent, element, platformId) {
        this.parent = parent;
        this.element = element;
        this.platformId = platformId;
        if (!isPlatformServer(this.platformId)) {
            this.resizeObserver = new ResizeObserver((entries) => {
                this.parent.marginBottom = entries[0].contentRect.height;
            });
        }
    }
    ngAfterViewInit() {
        this.resizeObserver && this.resizeObserver.observe(this.footer.nativeElement);
    }
    ngOnDestroy() {
        this.resizeObserver && this.resizeObserver.unobserve(this.footer.nativeElement);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterComponent, deps: [{ token: BsStickyFooterParentDirective }, { token: i0.ElementRef }, { token: PLATFORM_ID }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.2", type: BsStickyFooterComponent, selector: "bs-sticky-footer", viewQueries: [{ propertyName: "footer", first: true, predicate: ["foot"], descendants: true }], ngImport: i0, template: "<footer #foot class=\"footer position-absolute\">\n    <ng-content></ng-content>\n</footer>", styles: [".footer{bottom:0;left:0;right:0}::ng-deep html{position:relative;min-height:100%}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-sticky-footer', template: "<footer #foot class=\"footer position-absolute\">\n    <ng-content></ng-content>\n</footer>", styles: [".footer{bottom:0;left:0;right:0}::ng-deep html{position:relative;min-height:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: BsStickyFooterParentDirective }, { type: i0.ElementRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [PLATFORM_ID]
                }] }]; }, propDecorators: { footer: [{
                type: ViewChild,
                args: ['foot']
            }] } });

class BsStickyFooterModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterModule, declarations: [BsStickyFooterComponent, BsStickyFooterParentDirective], imports: [CommonModule], exports: [BsStickyFooterComponent, BsStickyFooterParentDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.2", ngImport: i0, type: BsStickyFooterModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [BsStickyFooterComponent, BsStickyFooterParentDirective],
                    imports: [CommonModule],
                    exports: [BsStickyFooterComponent, BsStickyFooterParentDirective],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsStickyFooterComponent, BsStickyFooterModule, BsStickyFooterParentDirective };
//# sourceMappingURL=mintplayer-ng-bootstrap-sticky-footer.mjs.map
