import { ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import { Color } from '@mintplayer/ng-bootstrap';
import { BsFormComponent } from '@mintplayer/ng-bootstrap/form';
import { HasId } from '@mintplayer/ng-bootstrap/has-id';
import { BehaviorSubject } from 'rxjs';
import { BsSuggestionTemplateContext } from '../directives';
import * as i0 from "@angular/core";
export declare class BsSearchboxComponent<T extends HasId<U>, U> {
    constructor(bsForm: BsFormComponent);
    colors: typeof Color;
    isBusy$: BehaviorSubject<boolean>;
    textbox: ElementRef<HTMLInputElement>;
    private _isOpen;
    get isOpen(): boolean;
    set isOpen(value: boolean);
    private _suggestions;
    get suggestions(): T[];
    set suggestions(value: T[]);
    private _selectedItem?;
    get selectedItem(): T | undefined;
    set selectedItem(value: T | undefined);
    selectedItemChange: EventEmitter<T | undefined>;
    searchterm$: BehaviorSubject<string>;
    get searchterm(): string;
    set searchterm(value: string);
    suggestionTemplate?: TemplateRef<BsSuggestionTemplateContext<T, U>>;
    enterSearchtermTemplate?: TemplateRef<T>;
    noResultsTemplate?: TemplateRef<T>;
    provideSuggestions: EventEmitter<string>;
    onSearchtermChange(searchterm: string): void;
    onSuggestionClicked(suggestion: T): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSearchboxComponent<any, any>, [{ optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsSearchboxComponent<any, any>, "bs-searchbox", never, { "isOpen": { "alias": "isOpen"; "required": false; }; "suggestions": { "alias": "suggestions"; "required": false; }; "selectedItem": { "alias": "selectedItem"; "required": false; }; "searchterm": { "alias": "searchterm"; "required": false; }; }, { "selectedItemChange": "selectedItemChange"; "provideSuggestions": "provideSuggestions"; }, never, ["*"], false, never>;
}
